import serial

import sys
sys.path.insert(0,"..")
from opcua import Client
from opcua import ua
import time

client = Client("opc.tcp://147.229.132.224:4840")
client.connect()


ser = serial.Serial('/dev/ttyACM0',9600)
measurmentVector = [0]


# Front side
dms_80_frontLeft  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_frontLeft")
dms_80_frontRight = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_frontRight")
sharp_frontMiddle = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.sharp_frontMiddle")

# Back side
dms_80_backLeft  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_backLeft")
dms_80_backRight  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_backRight")
sharp_backMiddle  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.sharp_backMiddle")

# Left side
dms_80_leftLeft  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_leftLeft")
dms_80_leftRight  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_leftRight")

# Right side
dms_80_rightLeft  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_rightLeft")
dms_80_rightRight  = client.get_node("ns=6;s=::Program:mecanum_wheel_sensor.dms_80_rightRight")

	
# Data value front side {left sensor}
datavalue_frontLeft = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_frontLeft.set_value(datavalue_frontLeft)
                
# Data value front side {right sensor}
datavalue_frontRight = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_frontRight.set_value(datavalue_frontRight)
            
# Data value front side {middle sensor}
datavalue_frontMiddle = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
sharp_frontMiddle.set_value(datavalue_frontMiddle)
            
# Data value right side {left sensor}
datavalue_rightLeft = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_rightLeft.set_value(datavalue_rightLeft)
            
# Data value right side {right sensor}
datavalue_rightRight = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_rightRight.set_value(datavalue_rightRight)

# Data value back side {left sensor}
datavalue_backLeft = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_backLeft.set_value(datavalue_backLeft)
            
# Data value back side {middle sensor}
datavalue_backMiddle = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
sharp_backMiddle.set_value(datavalue_backMiddle)
            
# Data value back side {right sensor}
datavalue_backRight = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_backRight.set_value(datavalue_backRight)
            
# Data value left side {left sensor}
datavalue_leftLeft = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_leftLeft.set_value(datavalue_leftLeft)
           
# Data value left side {right sensor}
datavalue_leftRight = ua.DataValue(ua.Variant(0,ua.VariantType.Int16))
dms_80_leftRight.set_value(datavalue_leftRight)


while True:
	s = str(ser.readline())
	d = s.split(' , ')
	measurmentVector = d
	
	print(d)
	
	newVector = measurmentVector[1:11]
	
	
	#print(newVector)
	

	if len(newVector) == 10:
            print(newVector)
            
            # Data value front side {left sensor}
            datavalue_frontLeft = ua.DataValue(ua.Variant(int(newVector[6]),ua.VariantType.Int16))
            dms_80_frontLeft.set_value(datavalue_frontLeft)
            
            # Data value front side {right sensor}
            datavalue_frontRight = ua.DataValue(ua.Variant(int(newVector[7]),ua.VariantType.Int16))
            dms_80_frontRight.set_value(datavalue_frontRight)
        
            # Data value front side {middle sensor}
            datavalue_frontMiddle = ua.DataValue(ua.Variant(int(newVector[8]),ua.VariantType.Int16))
            sharp_frontMiddle.set_value(datavalue_frontMiddle)
            
            # Data value right side {left sensor}
            datavalue_rightLeft = ua.DataValue(ua.Variant(int(newVector[5]),ua.VariantType.Int16))
            dms_80_rightLeft.set_value(datavalue_rightLeft)
            
            # Data value right side {right sensor}
            datavalue_rightRight = ua.DataValue(ua.Variant(int(newVector[4]),ua.VariantType.Int16))
            dms_80_rightRight.set_value(datavalue_rightRight)

            # Data value back side {left sensor}
            datavalue_backLeft = ua.DataValue(ua.Variant(int(newVector[3]),ua.VariantType.Int16))
            dms_80_backLeft.set_value(datavalue_backLeft)
            
            # Data value back side {middle sensor}
            datavalue_backMiddle = ua.DataValue(ua.Variant(int(newVector[9]),ua.VariantType.Int16))
            sharp_backMiddle.set_value(datavalue_backMiddle)
            
            # Data value back side {right sensor}
            datavalue_backRight = ua.DataValue(ua.Variant(int(newVector[2]),ua.VariantType.Int16))
            dms_80_backRight.set_value(datavalue_backRight)
            
            # Data value left side {left sensor}
            datavalue_leftLeft = ua.DataValue(ua.Variant(int(newVector[0]),ua.VariantType.Int16))
            dms_80_leftLeft.set_value(datavalue_leftLeft)
            
            # Data value left side {right sensor}
            datavalue_leftRight = ua.DataValue(ua.Variant(int(newVector[1]),ua.VariantType.Int16))
            dms_80_leftRight.set_value(datavalue_leftRight)
            time.sleep(1)


client.disconnect()